/* Tunguska, ternary virtual machine
 *
 * Copyright (C) 2007,2008 Viktor Lofgren
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "machine.h"

#ifndef disk_h
#define disk_h

class disk : public memory {
public:
	disk(machine* m, char* filename);
	~disk();

	void seek(const tryte& t);
	tryte getpos() const;

	void write();	/* Write to -disk-, read from -memory- */
	void read();	/* Read from -disk-, write to -memory- */

	void heartbeat();

	enum {
		DISKOP_NOOP = 0, 
		DISKOP_READ = 1, 
		DISKOP_WRITE = 2,
		DISKOP_SYNC = 3, 
		DISKOP_SEEK= 4, 
		DISKOP_GETPOS = 5, 
	};
private:
	tryte page;

	machine* m;
	char* filename;
};

#endif
