/* Tunguska, ternary virtual machine
 *
 * Copyright (C) 2007,2008 Viktor Lofgren
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef trit_h
#define trit_h

class trit {
protected:
	int data : 2;
public:
	enum {
		TRFALSE = -1, TRMU = 0, TRTRUE = 1, TRINVALID = -2
	};
	trit(int data) { this->data = data; };
	trit() { this->data = TRMU; };

	trit& operator=(const trit& t);
	trit& operator=(int i);
	trit operator&(const trit& t) const;
	trit operator|(const trit& t) const;
	trit operator^(const trit& t) const;
	trit operator!() const;

	trit& operator&=(const trit& t);
	trit& operator|=(const trit& t);
	trit& operator^=(const trit& t);

	trit operator>(const trit& t) const;
	trit operator>>(const trit& t) const;
	trit but(const trit& t) const;
	trit& but_this(const trit& t);

	int operator==(const trit& t) const;
	int operator!=(const trit& t) const;

	int to_int() const { return data; }
};

#endif
